/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "surface.pmh"

namespace fe
{

void SurfaceAccessorBase::fragmentWith(SurfaceAccessibleI::Element a_element,
	String a_attributeName)
{
//	feLog("SurfaceAccessorBase::fragmentWith \"%s\"\n",
//			a_attributeName.c_str());

	m_fragmentMap.clear();
	if(m_spSurfaceAccessibleI.isNull())
	{
		feLog("SurfaceAccessorBase::fragmentWith"
				" m_spSurfaceAccessibleI not set\n");
		return;
	}

	//* FIX this already is the accessor
	sp<SurfaceAccessorI> spAccessor=m_spSurfaceAccessibleI->accessor(
			a_element,a_attributeName);
	if(spAccessor.isNull())
	{
		feLog("SurfaceAccessorBase::fragmentWith"
				" access to attribute \"%s\" failed\n",
				a_attributeName.c_str());
		return;
	}

	U32 elementCount=spAccessor->count();
	for(U32 elementIndex=0;elementIndex<elementCount;elementIndex++)
	{
		String fragment=spAccessor->string(elementIndex);
		Fragment& rFragment=m_fragmentMap[fragment];
		rFragment.m_indexArray.push_back(elementIndex);

//		feLog("SurfaceAccessorBase::fragmentWith %d/%d fragment \"%s\"\n",
//				elementIndex,elementCount,fragment.c_str());
	}
}

} // namespace
